Index: gsdl/branches/gsdl-2.74/bin/script/buildcol.pl
===================================================================
--- gsdl/branches/gsdl-2.74/bin/script/buildcol.pl	(revision 14268)
+++ gsdl/branches/gsdl-2.74/bin/script/buildcol.pl	(revision 14270)
@@ -73,10 +73,5 @@
 
 my $arguments =
-    [ { 'name' => "disable_OAI",
-	'desc' => "{buildcol.disable_OAI}",
-	'type' => "flag",
-	'reqd' => "no",
-	'modegli' => "2" },
-      { 'name' => "remove_empty_classifications",
+    [ { 'name' => "remove_empty_classifications",
 	'desc' => "{buildcol.remove_empty_classifications}",
 	'type' => "flag",
@@ -205,5 +200,11 @@
 	'type' => "flag",
 	'reqd' => "no",
-	'hiddengli' => "yes" }
+	'hiddengli' => "yes" },
+      { 'name' => "disable_OAI",
+          'desc' => "{buildcol.disable_OAI}",
+          'type' => "flag",
+          'reqd' => "no",
+          'modegli' => "2",
+	  'hiddengli' => "yes" }
 
 #      { 'name' => "incremental_dlc",
@@ -353,26 +354,13 @@
     unshift (@INC, "$ENV{'GSDLCOLLECTDIR'}/perllib/plugins");
 
-    # read the configuration file (for gs2)
-    $configfilename = &util::filename_cat ($ENV{'GSDLCOLLECTDIR'}, "etc", "collect.cfg");
+    # Read in the collection configuration file.
     my ($collectcfg, $buildtype); 
-
-    if (-e $configfilename) {
-      $collectcfg = &colcfg::read_collect_cfg ($configfilename);
-      $gs_mode = "gs2";  
-    } 
-    else {
-
-      # If it is gs3
-      $configfilename = &util::filename_cat ($ENV{'GSDLCOLLECTDIR'}, "etc", "collectionConfig.xml");
-
-      if (!-e $configfilename) {
-	&gsprintf($out, "{common.cannot_find_cfg_file}\n", $configfilename) && die;
-      }
-      else {
+    ($configfilename, $gs_mode) = &colcfg::get_collect_cfg_name($out);
+    if ($gs_mode eq "gs2") {
+        $collectcfg = &colcfg::read_collect_cfg ($configfilename);
+    } elsif ($gs_mode eq "gs3") {
 	$collectcfg = &colcfg::read_collection_cfg_xml ($configfilename);
-	$gs_mode = "gs3";
-      }	
-    }
-    
+    }
+
     if ($verbosity !~ /\d+/) {
 	if (defined $collectcfg->{'verbosity'} && $collectcfg->{'verbosity'} =~ /\d+/) {
@@ -441,5 +429,6 @@
 	    $remove_empty_classifications = 1;
 	}
-    }    
+    }
+    
     
     if (defined $collectcfg->{'create_images'} && $collectcfg->{'create_images'} =~ /^true$/i) {
@@ -465,6 +454,7 @@
     $gli = 0 unless defined $gli;
 
+    # If the disable_OAI flag is not present, the option $disable_OAI with the value of 0 will be passed to basebuilder.pm
     $disable_OAI = 0 unless defined $disable_OAI;
-
+    
     # New argument to track whether build is incremental
     $incremental = 0 unless defined $incremental;
@@ -537,5 +527,11 @@
     # if a builder class has been created for this collection, use it
     # otherwise, use the mg or mgpp builder
-    if (-e "$ENV{'GSDLCOLLECTDIR'}/perllib/${collection}builder.pm") {
+    if (-e "$ENV{'GSDLCOLLECTDIR'}/custom/${collection}/perllib/custombuilder.pm") {
+	$builderdir = "$ENV{'GSDLCOLLECTDIR'}/custom/${collection}/perllib";
+	$buildertype = "custombuilder";
+    } elsif (-e "$ENV{'GSDLCOLLECTDIR'}/perllib/custombuilder.pm") {
+	$builderdir = "$ENV{'GSDLCOLLECTDIR'}/perllib";
+	$buildertype = "custombuilder";
+    } elsif (-e "$ENV{'GSDLCOLLECTDIR'}/perllib/${collection}builder.pm") {
 	$builderdir = "$ENV{'GSDLCOLLECTDIR'}/perllib";
 	$buildertype = "${collection}builder";
Index: gsdl/branches/gsdl-2.74/bin/script/downloadfrom.pl
===================================================================
--- gsdl/branches/gsdl-2.74/bin/script/downloadfrom.pl	(revision 14268)
+++ gsdl/branches/gsdl-2.74/bin/script/downloadfrom.pl	(revision 14270)
@@ -47,4 +47,7 @@
         'desc' => "{downloadfrom.download_mode.Web}",
 	'downloadname' => "WebDownload" },
+	  { 'name' => "MediaWiki",
+	  	'desc' => "{downloadfrom.download_mode.MediaWiki}",
+	  	'downloadname' => "MediaWikiDownload" },
       { 'name' => "OAI",
         'desc' => "{downloadfrom.download_mode.OAI}",
Index: gsdl/branches/gsdl-2.74/bin/script/gti.pl
===================================================================
--- gsdl/branches/gsdl-2.74/bin/script/gti.pl	(revision 14268)
+++ gsdl/branches/gsdl-2.74/bin/script/gti.pl	(revision 14270)
@@ -39,5 +39,6 @@
 
 
-my $anonymous_cvs_root = ":pserver:cvs_anon\@cvs.scms.waikato.ac.nz:2402/usr/local/global-cvs/gsdl-src";
+#my $anonymous_cvs_root = ":pserver:cvs_anon\@cvs.scms.waikato.ac.nz:2402/usr/local/global-cvs/gsdl-src";
+#my $anonymous_svn_root = "http://http://svn.greenstone.org/gsdl/trunk/";
 my $gsdl_root_directory = "$ENV{'GSDLHOME'}";
 my $gti_log_file = &util::filename_cat($gsdl_root_directory, "etc", "gti.log");
@@ -79,9 +80,13 @@
 	# 'target_file' => "gsdl-documentation/tutorials/xml-source/tutorial_{target_language_code}.xml" },
 
-      # Greenstone.org
+      # new Greenstone.org
       { 'key' => "greenorg",
-	'file_type' => "macrofile",
-	'source_file' => "greenorg/macros/english.dm",
-	'target_file' => "greenorg/macros/{iso_639_1_target_language_name}.dm" }
+        'file_type' => "resource_bundle",
+        'source_file' => "greenstoneorg/website/classes/Gsc.properties",
+        'target_file' => "greenstoneorg/website/classes/Gsc_{iso_639_1_target_language_name}.properties" 
+	# 'file_type' => "macrofile",
+	# 'source_file' => "greenorg/macros/english.dm",
+	# 'target_file' => "greenorg/macros/{iso_639_1_target_language_name}.dm" 
+      }
     ];
 
@@ -111,8 +116,8 @@
     }
     if ($gti_command =~ /^get-first-n-chunks-requiring-work$/i) {
-	print &get_first_n_chunks_requiring_work(@gti_command_arguments);
+	print &get_first_n_chunks_requiring_work(@gti_command_arguments);        
     }
     if ($gti_command =~ /^get-language-status$/i) {
-	print &get_language_status(@gti_command_arguments);
+	print &get_language_status(@gti_command_arguments);       
     }
     if ($gti_command =~ /^search-chunks$/i) {
@@ -248,5 +253,5 @@
     my @source_file_lines = &read_file_lines($source_file_path);
     my %source_file_key_to_line_mapping = &build_key_to_line_mapping(\@source_file_lines, $translation_file_type);
-
+    
     my $target_file_path = &util::filename_cat($gsdl_root_directory, $target_file);
     my @target_file_lines = &read_file_lines($target_file_path);
@@ -299,7 +304,11 @@
 	my $source_file_chunk_date = $source_file_key_to_last_update_date_mapping{$chunk_key};
 	my $source_file_chunk_text = &make_text_xml_safe($source_file_key_to_text_mapping{$chunk_key});
-
+	
+	if(!defined $source_file_chunk_date){
+		$source_file_chunk_date = "";
+	}
+	
 	$xml_response .= "    <Chunk key=\"" . &make_text_xml_safe($chunk_key) . "\">\n";
-	$xml_response .= "      <SourceFileText date=\"$source_file_chunk_date\">$source_file_chunk_text</SourceFileText>\n";
+	$xml_response .= "      <SourceFileText date=\"$source_file_chunk_date\">$source_file_chunk_text</SourceFileText>\n";	
 	$xml_response .= "      <TargetFileText></TargetFileText>\n";
 	$xml_response .= "    </Chunk>\n";
@@ -325,6 +334,10 @@
 	my $target_file_chunk_date = $target_file_key_to_last_update_date_mapping{$chunk_key};
 	my $target_file_chunk_text = &make_text_xml_safe($target_file_key_to_text_mapping{$chunk_key});
-
-	$xml_response .= "    <Chunk key=\"" . &make_text_xml_safe($chunk_key) . "\">\n";
+	
+	if(!defined $source_file_chunk_date){
+		$source_file_chunk_date = "";
+	}
+
+	$xml_response .= "    <Chunk key=\"" . &make_text_xml_safe($chunk_key) . "\">\n";	
 	$xml_response .= "      <SourceFileText date=\"$source_file_chunk_date\">$source_file_chunk_text</SourceFileText>\n";
 	$xml_response .= "      <TargetFileText date=\"$target_file_chunk_date\">$target_file_chunk_text</TargetFileText>\n";
@@ -636,5 +649,6 @@
     # The "2>/dev/null" is very important! If it is missing this will never return when run from the receptionist
     # unless ($translation_file_is_not_in_cvs) {
-	my $source_file_cvs_status = `cd $gsdl_root_directory; cvs -d $anonymous_cvs_root update $source_file 2>/dev/null`;
+	#my $source_file_cvs_status = `cd $gsdl_root_directory; cvs -d $anonymous_cvs_root update $source_file 2>/dev/null`;
+        my $source_file_cvs_status = `cd $gsdl_root_directory; svn status $source_file 2>/dev/null`;
 	if ($source_file_cvs_status =~ /^C /) {
 	    &throw_fatal_error("Source file $source_file_path conflicts with the repository.");
@@ -753,9 +767,10 @@
 	my $chunk_cvs_date = $key_to_cvs_date_mapping{$chunk_key};
 	$key_to_last_update_date_mapping{$chunk_key} = $chunk_cvs_date;
-
+                
 	# If a comment date exists and it is after the CVS date, use that instead
+        # need to convert the comment date format to SVN format
 	my $chunk_gti_comment = $key_to_gti_comment_mapping{$chunk_key};
 	if (defined($chunk_gti_comment) && $chunk_gti_comment =~ /(\d?\d-\D\D\D-\d\d\d\d)/) {
-	    my $chunk_comment_date = $1;
+	    my $chunk_comment_date = $1;            
 	    if ((!defined($chunk_cvs_date) || &is_date_after($chunk_comment_date, $chunk_cvs_date))) {
 		$key_to_last_update_date_mapping{$chunk_key} = $chunk_comment_date;
@@ -774,5 +789,8 @@
     # Use CVS to annotate each line of the file with the date it was last edited
     # The "2>/dev/null" is very important! If it is missing this will never return when run from the receptionist
-    my $cvs_annotated_file = `cd $gsdl_root_directory; cvs -d $anonymous_cvs_root annotate -F $filename 2>/dev/null`;
+    # my $cvs_annotated_file = `cd $gsdl_root_directory; cvs -d $anonymous_cvs_root annotate -F $filename 2>/dev/null`;    
+    # my $cvs_annotated_file = `cd $gsdl_root_directory; export PATH=.:/research/lh92/programs/subversion/bin; svn annotate -v --force $filename`;
+    my $cvs_annotated_file = `cd $gsdl_root_directory; svn annotate -v $filename`;
+    
     my @cvs_annotated_file_lines = split(/\n/, $cvs_annotated_file);
 
@@ -780,22 +798,31 @@
     foreach my $cvs_annotated_file_line (@cvs_annotated_file_lines) {
 	# Extract the date from the CVS annotation at the front
-	$cvs_annotated_file_line =~ s/^\S+\s+\(\S+\s+(\S+)\):\s//;
-	push(@cvs_annotated_file_lines_date, $1);
-    }
-
+        # cvs format : 07-Jun-02
+        # svn format : 2007-07-16
+	# $cvs_annotated_file_line =~ s/^\S+\s+\(\S+\s+(\S+)\):\s//;
+        $cvs_annotated_file_line =~ s/^\s+\S+\s+\S+\s(\S+)//; 
+        
+        push(@cvs_annotated_file_lines_date, $1);
+        
+        # trim extra date information in svn annotation format
+        # 15:42:49 +1200 (Wed, 21 Jun 2006)
+        $cvs_annotated_file_line =~ s/^\s+\S+\s\S+\s\((.+?)\)\s//; 
+    }    
+    
     # Build a key to line mapping for the CVS annotated file, for matching the chunk key to the CVS date
     my %key_to_line_mapping = &build_key_to_line_mapping(\@cvs_annotated_file_lines, $translation_file_type);
-
+        
     my %key_to_cvs_date_mapping = ();
     foreach my $chunk_key (keys(%key_to_line_mapping)) {
  	my $chunk_starting_line = (split(/-/, $key_to_line_mapping{$chunk_key}))[0];
  	my $chunk_finishing_line = (split(/-/, $key_to_line_mapping{$chunk_key}))[1];
-
+                
  	# Find the date this chunk was last edited, from the CVS annotation
- 	my $chunk_date = $cvs_annotated_file_lines_date[$chunk_starting_line];
+ 	my $chunk_date = $cvs_annotated_file_lines_date[$chunk_starting_line];        
  	for (my $l = ($chunk_starting_line + 1); $l <= $chunk_finishing_line; $l++) {
  	    if (&is_date_after($cvs_annotated_file_lines_date[$l], $chunk_date)) {
  		# This part of the chunk has been updated more recently
  		$chunk_date = $cvs_annotated_file_lines_date[$l];
+ 		
  	    }
  	}
@@ -861,5 +888,8 @@
 	my $source_chunk_last_update_date = $source_file_key_to_last_update_date_mapping->{$chunk_key};
  	my $target_chunk_last_update_date = $target_file_key_to_last_update_date_mapping->{$chunk_key};
-	if (defined($target_chunk_last_update_date) && &is_date_after($source_chunk_last_update_date, $target_chunk_last_update_date)) {
+        
+        # print "key: $chunk_key\nsource date : $source_chunk_last_update_date\ntarget date : $target_chunk_last_update_date\nafter? ". &is_date_after($source_chunk_last_update_date, $target_chunk_last_update_date) . "\n\n";        
+                	
+        if (defined($target_chunk_last_update_date) && &is_date_after($source_chunk_last_update_date, $target_chunk_last_update_date)) {
 	    # &log_message("Chunk with key $chunk_key needs updating.");
 	    push(@target_file_keys_requiring_updating, $chunk_key);
@@ -903,5 +933,5 @@
 
 # Returns 1 if $date1 is after $date2, 0 otherwise
-sub is_date_after
+sub is_date_after_cvs
 {
     my ($date1, $date2) = @_;
@@ -909,4 +939,8 @@
 		  "Jul", 7, "Aug", 8, "Sep", 9, "Oct", 10, "Nov", 11, "Dec", 12);
 
+	if(!defined $date1) {
+		return 1;
+	}
+
     my @date1parts = split(/-/, $date1);
     my @date2parts = split(/-/, $date2);
@@ -915,9 +949,9 @@
     my $year1 = $date1parts[2];
     if ($year1 < 80) {
-	$year1 += 2000;
+		$year1 += 2000;
     }
     my $year2 = $date2parts[2];
     if ($year2 < 80) {
-	$year2 += 2000;
+		$year2 += 2000;
     }
 
@@ -939,4 +973,54 @@
     }
 
+    return 0;
+}
+
+sub is_date_after
+{
+    my ($date1, $date2) = @_;
+    
+    if(!defined $date1) {
+      return 1;
+    }
+    if(!defined $date2) {
+      return 0;
+    }
+    
+    # 16-Aug-2006
+    if($date1=~ /(\d+?)-(\S\S\S)-(\d\d\d\d)/){
+       my %months = ("Jan", "01", "Feb", "02", "Mar", "03", "Apr",  "04", "May",  "05", "Jun",  "06",
+		  "Jul", "07", "Aug", "08", "Sep", "09", "Oct", "10", "Nov", "11", "Dec", "12");
+       $date1=$3 . "-" . $months{$2} . "-" . $1;
+       # print "** converted date1: $date1\n";
+    }
+    if($date2=~ /(\d+?)-(\S\S\S)-(\d\d\d\d)/){
+       my %months = ("Jan", "01", "Feb", "02", "Mar", "03", "Apr",  "04", "May",  "05", "Jun",  "06",
+		  "Jul", "07", "Aug", "08", "Sep", "09", "Oct", "10", "Nov", "11", "Dec", "12");
+       $date2=$3 . "-" . $months{$2} . "-" . $1;
+       # print "** converted date2: $date2\n";
+    }
+    
+    
+    # 2006-08-16
+    my @date1parts = split(/-/, $date1);
+    my @date2parts = split(/-/, $date2);
+    
+    # Compare year
+    if ($date1parts[0] > $date2parts[0]) {
+	return 1;
+    }
+    elsif ($date1parts[0] == $date2parts[0]) {
+	# Year is the same, so compare month
+	if ($date1parts[1] > $date2parts[1]) {
+	    return 1;
+	}
+	elsif ($date1parts[1] == $date2parts[1]) {
+	    # Month is the same, so compare day
+	    if ($date1parts[2] > $date2parts[2]) {
+		return 1;
+	    }
+	}
+    }    
+    
     return 0;
 }
Index: gsdl/branches/gsdl-2.74/bin/script/mkcol.pl
===================================================================
--- gsdl/branches/gsdl-2.74/bin/script/mkcol.pl	(revision 14268)
+++ gsdl/branches/gsdl-2.74/bin/script/mkcol.pl	(revision 14270)
@@ -76,5 +76,5 @@
 	'reqd' => "no" },
       { 'name' => "gs3mode",
-	'desc' => "",
+	'desc' => "mkcol.gs3mode",
 	'type' => "flag",
 	'reqd' => "no" },
Index: gsdl/branches/gsdl-2.74/cgi-bin/gliserver.pl
===================================================================
--- gsdl/branches/gsdl-2.74/cgi-bin/gliserver.pl	(revision 14268)
+++ gsdl/branches/gsdl-2.74/cgi-bin/gliserver.pl	(revision 14270)
@@ -1,9 +1,30 @@
 #!perl -w
-
 # Need to specify the full path of Perl above
 
 
-use gsdlCGI;
 use strict;
+
+
+# Set this to 1 to work around IIS 6 craziness
+my $iis6_mode = 0;
+
+
+# IIS 6: for some reason, IIS runs this script with the working directory set to the Greenstone
+#   directory rather than the cgi-bin directory, causing lots of stuff to fail
+if ($iis6_mode)
+{
+    # Change into cgi-bin directory
+    chdir("cgi-bin");
+}
+
+
+# We use require and an eval here (instead of "use") to catch any errors loading the module (for IIS)
+eval("require \"gsdlCGI.pm\"");
+if ($@)
+{
+    print STDOUT "Content-type:text/plain\n\n";
+    print STDOUT "ERROR: $@\n";
+    exit 0;
+}
 
 
@@ -109,5 +130,4 @@
 sub authenticate_user
 {
-    
     my $gsdl_cgi = shift(@_);
     my $username = shift(@_);
@@ -244,7 +264,17 @@
     my $installation_status = "";
 
+    print STDOUT "Content-type:text/plain\n\n";
+
     # Check that Java is installed and accessible
     my $java = $gsdl_cgi->get_java_path();
     my $java_command = "$java -version 2>&1";
+
+    # IIS 6: redirecting output from STDERR to STDOUT just doesn't work, so we have to let it go
+    #   directly out to the page
+    if ($iis6_mode)
+    {
+	$java_command = "java -version";
+    }
+
     my $java_output = `$java_command`;
     my $java_status = $?;
@@ -265,8 +295,8 @@
 
     if ($installation_ok) {
-	$gsdl_cgi->generate_ok_message($installation_status . "\nInstallation OK!");
+	print STDOUT $installation_status . "\nInstallation OK!";
     }
     else {
-	$gsdl_cgi->generate_error($installation_status);
+	print STDOUT $installation_status;
     }
 }
@@ -563,5 +593,4 @@
     }
 
-    print STDOUT "Content-type:text/plain\n\n";
     foreach my $cgi_arg_name ($gsdl_cgi->param) {
 	my $cgi_arg_value = $gsdl_cgi->clean_param($cgi_arg_name) || "";
@@ -575,5 +604,15 @@
     }
 
+    print STDOUT "Content-type:text/plain\n\n";
+
     my $perl_command = "perl -S $script $perl_args 2>&1";
+
+    # IIS 6: redirecting output from STDERR to STDOUT just doesn't work, so we have to let it go
+    #   directly out to the page
+    if ($iis6_mode)
+    {
+	$perl_command = "perl -S $script $perl_args";
+    }
+
     my $perl_output = `$perl_command`;
     my $perl_status = $?;
@@ -582,7 +621,8 @@
     }
 
-    print STDOUT "Content-type:text/plain\n\n";
-    print STDOUT $perl_output;
-
+    if (defined($perl_output))
+    {
+	print STDOUT $perl_output;
+    }
 }
 
@@ -728,10 +768,19 @@
     }
 
+    print STDOUT "Content-type:text/plain\n\n";
+
     my $perl_command = "perl -S $script $perl_args 2>&1";
+
+    # IIS 6: redirecting output from STDERR to STDOUT just doesn't work, so we have to let it go
+    #   directly out to the page
+    if ($iis6_mode)
+    {
+	$perl_command = "perl -S $script $perl_args";
+    }
+
     if (!open(PIN, "$perl_command |")) {
 	$gsdl_cgi->generate_error("Unable to execute command: $perl_command");
     }
 
-    print STDOUT "Content-type:text/plain\n\n";
     while (defined (my $perl_output_line = <PIN>)) {
 	print STDOUT $perl_output_line;
@@ -799,10 +848,18 @@
 
     # Read the uploaded data and write it out to file
+    # We have to pass the size of the uploaded data in the "fs" argument because IIS 6 seems to be
+    #   completely incapable of working this out otherwise (causing the old code to crash)
     my $buf;
     my $num_bytes = 0;
+    my $num_bytes_remaining = $gsdl_cgi->clean_param("fs");
+    my $bytes_to_read = $num_bytes_remaining;
+    if ($bytes_to_read > 1024) { $bytes_to_read = 1024; }
     binmode(FOUT);
-    while (read(STDIN, $buf, 1024) > 0) {
+    while (read(STDIN, $buf, $bytes_to_read) > 0) {
 	print FOUT $buf;
 	$num_bytes += length($buf);
+	$num_bytes_remaining -= length($buf);
+	$bytes_to_read = $num_bytes_remaining;
+	if ($bytes_to_read > 1024) { $bytes_to_read = 1024; }
     }
     close(FOUT);
Index: gsdl/branches/gsdl-2.74/cgi-bin/gsdlCGI.pm
===================================================================
--- gsdl/branches/gsdl-2.74/cgi-bin/gsdlCGI.pm	(revision 14268)
+++ gsdl/branches/gsdl-2.74/cgi-bin/gsdlCGI.pm	(revision 14270)
@@ -101,5 +101,5 @@
     print STDOUT $full_mess;
 
-    die $full_mess;
+    exit 0;
 }
 
Index: gsdl/branches/gsdl-2.74/macros/style.dm
===================================================================
--- gsdl/branches/gsdl-2.74/macros/style.dm	(revision 14268)
+++ gsdl/branches/gsdl-2.74/macros/style.dm	(revision 14270)
@@ -100,5 +100,6 @@
 # _pagetitle_
 # _globalscripts_
-_htmlhead_ {<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN">
+_htmlhead_ {<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
+"http://www.w3.org/TR/html4/loose.dtd">
 
 <html_htmlextra_>
Index: gsdl/branches/gsdl-2.74/perllib/basebuilder.pm
===================================================================
--- gsdl/branches/gsdl-2.74/perllib/basebuilder.pm	(revision 14268)
+++ gsdl/branches/gsdl-2.74/perllib/basebuilder.pm	(revision 14270)
@@ -26,4 +26,7 @@
 package basebuilder;
 
+use strict;
+no strict 'refs'; # allow filehandles to be variables and viceversa
+
 use classify;
 use cfgread;
@@ -56,7 +59,7 @@
 	$outhandle, $no_text, $failhandle, $gli, $disable_OAI) = @_;
 
-    $outhandle = STDERR unless defined $outhandle;
+    $outhandle = *STDERR unless defined $outhandle;
     $no_text = 0 unless defined $no_text;
-    $failhandle = STDERR unless defined $failhandle;
+    $failhandle = *STDERR unless defined $failhandle;
 
     # create a builder object
@@ -80,23 +83,15 @@
 
     $self->{'gli'} = 0 unless defined $self->{'gli'};
+    
+    # disable_OIA applies to greenstone 3 only and is only passed to &colcfg::write_build_cfg_xml (then cfgread4gs3::write_cfg_file) when writing the buildConfig.xml
     $self->{'disable_OAI'} = 0 unless defined $self->{'disable_OAI'};
-    
-    # read in the collection configuration file
-    my $colcfgname = "$ENV{'GSDLCOLLECTDIR'}/etc/collect.cfg";
-    if (-e $colcfgname) {
-      ##$self->{'collect_cfg'} = &colcfg::read_collection_cfg_xml ($colcfgname);
-      $self->{'collect_cfg'} = &colcfg::read_collect_cfg ($colcfgname);
-      $gs_mode = "gs2";
-    }
-    else {
-      my $colcfgname = "$ENV{'GSDLCOLLECTDIR'}/etc/collectionConfig.xml";
-      if (!-e $colcfgname) {
-	die "mgbuilder::new - couldn't find collectionConfig.xml for collection $collection\n";
-      }
-      else {
-	#$self->{'collect_cfg'} = &colcfg::read_collect_cfg ($colcfgname);
-        $self->{'collect_cfg'} = &colcfg::read_collection_cfg_xml ($colcfgname);
-	$gs_mode = "gs3";
-      }
+
+    # Read in the collection configuration file.
+    my ($colcfgname);
+    ($colcfgname, $gs_mode) = &colcfg::get_collect_cfg_name($outhandle);
+    if ($gs_mode eq "gs2") {
+        $self->{'collect_cfg'} = &colcfg::read_collect_cfg ($colcfgname);
+    } elsif ($gs_mode eq "gs3") {
+	$self->{'collect_cfg'} = &colcfg::read_collection_cfg_xml ($colcfgname);
     }
     
@@ -196,5 +191,11 @@
     my ($buildprocdir, $buildproctype);
     my $collection = $self->{'collection'};
-    if (-e "$ENV{'GSDLCOLLECTDIR'}/perllib/${collection}buildproc.pm") {
+    if (-e "$ENV{'GSDLCOLLECTDIR'}/custom/${collection}/perllib/custombuildproc.pm") {
+	$buildprocdir = "$ENV{'GSDLCOLLECTDIR'}/custom/${collection}/perllib";
+	$buildproctype = "custombuildproc";
+    } elsif (-e "$ENV{'GSDLCOLLECTDIR'}/perllib/custombuildproc.pm") {
+	$buildprocdir = "$ENV{'GSDLCOLLECTDIR'}/perllib";
+	$buildproctype = "custombuildproc";
+    } elsif (-e "$ENV{'GSDLCOLLECTDIR'}/perllib/${collection}buildproc.pm") {
 	$buildprocdir = "$ENV{'GSDLCOLLECTDIR'}/perllib";
 	$buildproctype = "${collection}buildproc";
@@ -240,11 +241,4 @@
     $self->{'maxnumeric'} = $maxnumeric;
 }
-# It seems we don't need this sub
-#sub set_disable_OAI {
-#    my $disable_OAI = shift (@_);
-#    my ($disable_OAI = @_;
-#
-#    $self->{'disable_OAI'} = $disable_OAI;
-#}
 sub set_strip_html {
     my $self = shift (@_);
@@ -279,7 +273,5 @@
     # and their directory names (includes subcolls and langs)
     $self->{'index_mapping'} = $self->create_index_mapping ($indexes);
-
-    my $indexmap = $self->{'index_mapping'}->{'indexmap'};
-
+   
     # build each of the indexes
     foreach my $index (@$indexes) {
@@ -351,5 +343,5 @@
     my ($handle);
     if ($self->{'debug'}) {
-	$handle = STDOUT;
+	$handle = *STDOUT;
     } else {
 	if (!-e "$txt2db_exe" || !open (PIPEOUT, "| txt2db$exe \"$fulldbname\"")) {
@@ -357,5 +349,5 @@
 	    die "builder::make_infodatabase - couldn't run $txt2db_exe\n";
 	}
-	$handle = basebuilder::PIPEOUT;
+	$handle = *PIPEOUT;
     }
     
@@ -439,8 +431,5 @@
     $build_cfg->{'numsections'} = $self->{'buildproc'}->get_num_sections();
     $build_cfg->{'numbytes'} = $self->{'buildproc'}->get_num_bytes();
-
-    # store whether to disable OAI service
-    $build_cfg->{'disable_OAI'} = $self->{'disable_OAI'};
-        
+    
     # store the mapping between the index names and the directory names
     # the index map is used to determine what indexes there are, so any that are not built should not be put into the map.
@@ -478,10 +467,8 @@
 
     if ($gs_mode eq "gs2") {
-      #&colcfg::write_build_cfg_xml("$self->{'build_dir'}/buildConfig.xml", $build_cfg, $self->{'collect_cfg'});
       &colcfg::write_build_cfg("$self->{'build_dir'}/build.cfg", $build_cfg);
     }
     if ($gs_mode eq "gs3") {
-      #&colcfg::write_build_cfg("$self->{'build_dir'}/build.cfg", $build_cfg);
-      &colcfg::write_build_cfg_xml("$self->{'build_dir'}/buildConfig.xml", $build_cfg, $self->{'collect_cfg'});
+      &colcfg::write_build_cfg_xml("$self->{'build_dir'}/buildConfig.xml", $build_cfg, $self->{'collect_cfg'}, $self->{'disable_OAI'});
     }    
 
Index: gsdl/branches/gsdl-2.74/perllib/cfgread4gs3.pm
===================================================================
--- gsdl/branches/gsdl-2.74/perllib/cfgread4gs3.pm	(revision 14268)
+++ gsdl/branches/gsdl-2.74/perllib/cfgread4gs3.pm	(revision 14270)
@@ -337,6 +337,6 @@
     }
 
-    print "*** collectionConfig.xml internal ***\n";
-    &Display; 
+    #print "*** collectionConfig.xml internal ***\n";
+    #&Display; 
     return $data;
 }
@@ -350,13 +350,13 @@
 # Create the buildConfig.xml file for a specific collection
 sub write_cfg_file {
-    # this sub is called make_auxiliary_files() in basebuilder.pm
+    # this sub is called in make_auxiliary_files() in basebuilder.pm
     # the received args: $buildoutfile - destination file: buildConfig.xml
     #                    $buildcfg - all build options, eg, disable_OAI
     #                    $collectcfg - contents of collectionConfig.xml read in by read_cfg_file sub in cfgread4gs3.pm.
-    my ($buildoutfile, $buildcfg, $collectcfg) = @_;
+    my ($buildoutfile, $buildcfg, $collectcfg, $disable_OAI) = @_;
     my $line = [];
 
     if (!open (COLCFG, ">$buildoutfile")) {
-	print STDERR "cfgread::write_cfg_file couldn't write the cfg file $buildoutfile\n";
+	print STDERR "cfgread4gs3::write_cfg_file couldn't write the build config file $buildoutfile\n";
 	die;
     }
@@ -391,6 +391,6 @@
 
     # This serviceRack enables the collection to provide the oai metadata retrieve service, which is served by the OAIPMH.java class
-    # For each collection, we write the following serviceRack in the collection's buildConfig.xml file as follows if the 'disable_OAI' argument is not ticked in GLI (or equivalently, a 'disable_OAI' flag is not specified on the command line). There are also other configurations in the OAIConfig.xml.
-    if ($buildcfg->{'disable_OAI'} == 0) {
+    # For each collection, we write the following serviceRack in the collection's buildConfig.xml file if the 'disable_OAI' argument is not checked in the GLI (or equivalently, a 'disable_OAI' flag is not specified on the command line). There are also other configurations in the OAIConfig.xml.
+    if ($disable_OAI == 0) {
       &write_line('COLCFG', ["<serviceRack name=\"OAIPMH\">"]);
       if (defined $buildcfg->{'indexstem'}) {
Index: gsdl/branches/gsdl-2.74/perllib/classify.pm
===================================================================
--- gsdl/branches/gsdl-2.74/perllib/classify.pm	(revision 14268)
+++ gsdl/branches/gsdl-2.74/perllib/classify.pm	(revision 14270)
@@ -49,10 +49,14 @@
 
     # find the classifier
-    my $customclassname = &util::filename_cat($ENV{'GSDLCOLLECTDIR'}, "custom", $ENV{'GSDLCOLLECTION'},
+    my $customclassname;
+    if (defined($ENV{'GSDLCOLLECTION'}))
+    {
+	$customclassname = &util::filename_cat($ENV{'GSDLCOLLECTDIR'}, "custom", $ENV{'GSDLCOLLECTION'},
                                               "perllib", "classify", "${classifier}.pm");
+    }
     my $colclassname = &util::filename_cat($ENV{'GSDLCOLLECTDIR'}, "perllib", "classify", "${classifier}.pm");
     my $mainclassname = &util::filename_cat($ENV{'GSDLHOME'}, "perllib", "classify", "${classifier}.pm");
 
-    if (-e $customclassname) { require $customclassname; }
+    if (defined($customclassname) && -e $customclassname) { require $customclassname; }
     elsif (-e $colclassname) { require $colclassname; }
     elsif (-e $mainclassname) { require $mainclassname; }
Index: gsdl/branches/gsdl-2.74/perllib/colcfg.pm
===================================================================
--- gsdl/branches/gsdl-2.74/perllib/colcfg.pm	(revision 14268)
+++ gsdl/branches/gsdl-2.74/perllib/colcfg.pm	(revision 14270)
@@ -100,7 +100,7 @@
 }
 sub write_build_cfg_xml {
-    my ($buildoutfile, $buildcfg, $collectcfg) = @_;
+    my ($buildoutfile, $buildcfg, $collectcfg, $disable_OAI) = @_;
 
-    return &cfgread4gs3::write_cfg_file ($buildoutfile, $buildcfg, $collectcfg);
+    return &cfgread4gs3::write_cfg_file ($buildoutfile, $buildcfg, $collectcfg, $disable_OAI);
 }
 
@@ -148,5 +148,5 @@
 
     return &cfgread::read_cfg_file ($filename, 
-		   q/^(builddate|buildtype|numdocs|numsections|numwords|numbytes|maxnumeric|textlevel|indexstem|stemindexes)$/, 
+		   q/^(builddate|buildtype|numdocs|numsections|numwords|numbytes|maxnumeric|textlevel|indexstem|stemindexes)$/,
 		   q/^(indexmap|subcollectionmap|languagemap|notbuilt|indexfields|indexfieldmap|indexlevels|levelmap)$/);
 				    
@@ -157,5 +157,5 @@
 
     &cfgread::write_cfg_file($filename, $data,
-	       q/^(builddate|buildtype|numdocs|numsections|numwords|numbytes|maxnumeric|textlevel|indexstem|stemindexes)$/, 
+	       q/^(builddate|buildtype|numdocs|numsections|numwords|numbytes|maxnumeric|textlevel|indexstem|stemindexes)$/,
 	       q/^(indexmap|subcollectionmap|languagemap|notbuilt|indexfields|indexfieldmap|indexlevels|levelmap)$/);		     
 }
